VERSION 4.00
Begin VB.Form FAllAbout 
   Caption         =   "All About..."
   ClientHeight    =   6090
   ClientLeft      =   2655
   ClientTop       =   2025
   ClientWidth     =   7875
   BeginProperty Font 
      name            =   "MS Sans Serif"
      charset         =   0
      weight          =   700
      size            =   8.25
      underline       =   0   'False
      italic          =   0   'False
      strikethrough   =   0   'False
   EndProperty
   Height          =   6780
   Icon            =   "ALLABOUT.frx":0000
   Left            =   2595
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   6090
   ScaleWidth      =   7875
   Top             =   1395
   Width           =   7995
   Begin TabDlg.SSTab tabAbout 
      Height          =   5625
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   7305
      _Version        =   65536
      _ExtentX        =   12885
      _ExtentY        =   9922
      _StockProps     =   15
      Caption         =   "Ve&rsion"
      TabsPerRow      =   4
      Tab             =   3
      TabOrientation  =   0
      Tabs            =   4
      Style           =   0
      TabMaxWidth     =   0
      TabHeight       =   529
      TabCaption(0)   =   "&System"
      Tab(0).ControlCount=   1
      Tab(0).ControlEnabled=   0   'False
      Tab(0).Control(0)=   "lbl(0)"
      TabCaption(1)   =   "&Video"
      Tab(1).ControlCount=   1
      Tab(1).ControlEnabled=   0   'False
      Tab(1).Control(0)=   "lbl(1)"
      TabCaption(2)   =   "&Drives"
      Tab(2).ControlCount=   2
      Tab(2).ControlEnabled=   0   'False
      Tab(2).Control(0)=   "cmdDrives"
      Tab(2).Control(1)=   "lbl(2)"
      TabCaption(3)   =   "Ve&rsion"
      Tab(3).ControlCount=   3
      Tab(3).ControlEnabled=   -1  'True
      Tab(3).Control(0)=   "lblFile"
      Tab(3).Control(1)=   "lbl(3)"
      Tab(3).Control(2)=   "cmdVersion"
      Begin VB.CommandButton cmdDrives 
         Caption         =   "&Update..."
         Height          =   375
         Left            =   -71040
         TabIndex        =   6
         Top             =   480
         Width           =   1215
      End
      Begin VB.CommandButton cmdVersion 
         Caption         =   "&New..."
         Height          =   375
         Left            =   5805
         TabIndex        =   1
         Top             =   480
         Width           =   1095
      End
      Begin VB.Label lbl 
         Height          =   4215
         Index           =   3
         Left            =   210
         TabIndex        =   2
         Top             =   1080
         Width           =   6855
      End
      Begin VB.Label lbl 
         Height          =   4095
         Index           =   2
         Left            =   -74640
         TabIndex        =   7
         Top             =   1185
         Width           =   6675
      End
      Begin VB.Label lbl 
         Height          =   4815
         Index           =   1
         Left            =   -74640
         TabIndex        =   5
         Top             =   720
         Width           =   6600
      End
      Begin VB.Label lbl 
         Height          =   4695
         Index           =   0
         Left            =   -74640
         TabIndex        =   4
         Top             =   720
         Width           =   6645
      End
      Begin VB.Label lblFile 
         Height          =   375
         Left            =   225
         TabIndex        =   3
         Top             =   600
         Width           =   4095
      End
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuAbout 
         Caption         =   "&About..."
      End
      Begin VB.Menu mnuSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "FAllAbout"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

Private sExe As String
Private fUpdate As Boolean

Const ordSystem = 0
Const ordVideo = 1
Const ordDrives = 2
Const ordVersion = 3

Private Sub Form_Initialize()
    BugMessage "Initializing All About"
End Sub

Private Sub Form_Load()
    BugMessage "Loading All About"
    ValidateVBUtil
#If Win32 Then
    sExe = "vb32.exe"
#Else
    sExe = "vb.exe"
#End If
    If IsExe() Then sExe = App.ExeName & ".EXE"
    ' First tab no matter what it is
    tabAbout.Tab = 0
    tabAbout_Click (0)
End Sub

Private Sub Form_Terminate()
    BugMessage "Terminating All About"
End Sub

Private Sub Form_Unload(Cancel As Integer)
    BugMessage "Unloading All About"
End Sub
   
Private Sub cmdDrives_Click()
    fUpdate = True
    tabAbout_Click (0)
End Sub

Private Sub Form_Activate()
    BugMessage "Activating All About"
End Sub


Private Sub cmdVersion_Click()
    Dim f As Boolean, f32Options As Long
    Dim sFileTitle As String, sFilter As String
    sFilter = "Executable |*.exe;*.dll;*.vbx;*.ocx;*.fon|"
    sFilter = sFilter & "Program |*.exe|DLL |*.dll|"
    sFilter = sFilter & "Control |*.vbx;*.ocx| Font | *.fon"
    f32Options = cdlOFNHideReadOnly Or cdlOFNFileMustExist
    f = VBGetOpenFileName( _
        vFileName:=sExe, _
        vFileTitle:=sFileTitle, _
        vFlags:=f32Options, _
        vOwner:=Me.hWnd, _
        vFilter:=sFilter)
    If f Then tabAbout_Click (0)
End Sub

''@B ValidateVBUtil
Sub ValidateVBUtil()
    Dim verUtil As New CVersion, f As Boolean
    Const sUtil = "C Utility Functions for Visual Basic"
#If Win32 Then
    f = verUtil.Create("VBUTIL32.DLL")
#Else
    f = verUtil.Create("VBUTIL16.DLL")
#End If
    If Not f Or _
        verUtil.FileVersionString <> "1.00" Or _
        verUtil.Company <> "MS-PRESS" Or _
        verUtil.Description <> sUtil Then
        MsgBox "Invalid DLL"
        End
    End If
End Sub
''@E ValidateVBUtil

''@B mnuAbout
Private Sub mnuAbout_Click()
    Dim about As New FAbout
    about.UserInfo(2) = "Don't even think " & _
                        "about stealing this program"
    Load about
    If about.Error Then MsgBox "I don't know nuttin'"
    Unload about
End Sub
''@E mnuAbout

Private Sub mnuExit_Click()
    Unload Me
End Sub

Private Sub tabAbout_Click(PreviousTab As Integer)
    Dim s As String
    Select Case tabAbout.Tab
    Case ordSystem
        lbl(ordSystem) = ShowSystem
        
    Case ordVideo
        lbl(ordVideo) = ShowVideo
    
    Case ordDrives
        lbl(ordDrives).Caption = "Getting drive information..."
        lbl(ordDrives).Refresh
        lbl(ordDrives).Caption = ShowDrives(fUpdate)
        fUpdate = False
        cmdDrives.Visible = True

    Case ordVersion
        lblFile.Caption = sExe
        lbl(ordVersion) = ShowVersion(sExe)
        
    End Select
    
End Sub


Private Function ShowSystem() As String
    Dim s As String
    s = "Free Memory: " & System.FreeMemory & " KB" & sCrLf & _
        "Free Resources: " & System.FreeResources & "%"
#If Win32 = False Then
    s = s = " (" & System.FreeGdiResources & "% GDI, " & _
            System.FreeUserResources & "% USER)"
#End If
    s = s & sCrLf & "Windows Version: " & System.WinMajor & "." & _
            System.WinMinor & sCrLf
    s = s & "MS-DOS Version: " & System.DosMajor & "." & _
            System.DosMinor & sCrLf & _
        "Coprocessor: " & IIf(System.HasCoprocessor, "Yes", "No") & sCrLf & _
        "Under 32-bit: " & IIf(System.IsUnder32, "Yes", "No") & sCrLf & _
        "Paging: " & IIf(System.HasPaging, "Yes", "No") & sCrLf & _
        "Processor: " & System.Processor & sCrLf & _
        "Mode: " & System.Mode & sCrLf
    s = s & "Windows Directory: " & System.WindowsDir & sCrLf & _
        "System Directory: " & System.SystemDir & sCrLf & _
        "User Name: " & System.USER & sCrLf & _
        "Machine Name: " & System.Machine & sCrLf
    ShowSystem = s
End Function

Private Function ShowDrives(fUpdate As Boolean) As String

    Static s As String
    If Not fUpdate And s <> sEmpty Then
        ShowDrives = s
        Exit Function
    End If
       
    Dim driveDat As New CDrive
    Dim driveCur As New CDrive
    
    driveCur.Number = 0                ' Set to current drive
    
    s = "Drive information for current drive:" & sCrLf
    Const sBFormat = "#,###,###,##0"
    With driveCur
        s = s & "Drive " & .Root & " [" & .Label & "] (" & _
                .KindStr & ") has " & _
                Format$(.FreeBytes, sBFormat) & " free from " & _
                Format$(.TotalBytes, sBFormat) & sCrLf
    End With
    
    s = s & sCrLf
    s = s & "Drive information for available drives:" & sCrLf
    Dim drives As New NDrives
    Dim rdrive As CDrive
    'For Each rdrive In drives
    For Each rdrive In drives.Items
        With rdrive
            s = s & "Drive " & .Root & " [" & .Label & "] (" & .KindStr & _
                    ") has " & Format$(.FreeBytes, sBFormat) & _
                    " free from " & Format$(.TotalBytes, sBFormat) & sCrLf
        End With
    Next
    ShowDrives = s
    
End Function
        
Private Function ShowVersion(sFile As String) As String
    Dim vc As New CVersion, s As String
    If Not vc.Create(sFile) Then
        vc.ExeName = sFile
        If vc.ExeName = sEmpty Then
            lbl(ordVersion).Caption = "Can't get version"
            Exit Function
        End If
    End If
    
    If vc.Description <> sEmpty Then
        s = s & "Description: " & vc.Description & sCrLf
    End If
    If vc.InternalName <> sEmpty Then
        s = s & "Internal name: " & vc.InternalName & sCrLf
    End If
    If vc.OriginalFilename <> sEmpty Then
        s = s & "Original filename: " & vc.OriginalFilename & sCrLf
    End If
    If vc.TimeStamp <> 0& Then
        s = s & "Time stamp: " & vc.TimeStamp & sCrLf
    End If
    s = s & "File version: " & vc.FullFileVersion & sCrLf
    s = s & "Product version: " & vc.FullProductVersion & sCrLf
    If vc.FileVersionString <> sEmpty Then
        s = s & "File version string: " & vc.FileVersionString & sCrLf
    End If
    If vc.ProductVersionString <> sEmpty Then
        s = s & "Product version string: " & vc.ProductVersionString & sCrLf
    End If
    If vc.ProductName <> sEmpty Then
        s = s & "Product: " & vc.ProductName & sCrLf
    End If
    If vc.Company <> sEmpty Then
        s = s & "Company: " & vc.Company & sCrLf
    End If
    If vc.Comments <> sEmpty Then
        s = s & "Comments: " & vc.Comments & sCrLf
    End If
    If vc.BuildString <> sEmpty Then
        s = s & "Build: " & vc.BuildString & sCrLf
    End If
    If vc.Environment <> sEmpty Then
        s = s & "Environment: " & vc.Environment & sCrLf
    End If
    If vc.ExeType <> sEmpty Then
        s = s & "Executable type: " & vc.ExeType & sCrLf
    End If
    If vc.Copyright <> sEmpty Then
        s = s & "Copyright: " & vc.Copyright & sCrLf
    End If
    If vc.Trademarks <> sEmpty Then
        s = s & "Trademarks: " & vc.Trademarks & sCrLf
    End If
    Dim sT As String
    sT = vc.Custom("CustomBuild")
    If sT <> sEmpty Then
        s = s & "Custom build: " & sT & sCrLf
    End If
    sT = vc.Custom("SpecialBuild")
    If sT <> sEmpty Then
        s = s & "Special build: " & sT & sCrLf
    End If
    ShowVersion = s
End Function

Private Function ShowVideo() As String
    Dim Video As New CVideo, s As String
    With Video
        s = "Display type: " & _
            Choose(.Technology + 1, "Plotter", "Raster Display", _
                "Raster Printer", "Raster Camera", "Character Stream", _
                "Metafile", "Display File") & sCrLf
        s = s & "Screen size: " & .XPixels & "," & .YPixels & sCrLf
        s = s & "Bits per pixel: " & .BitsPerPixel
        s = s & "  Color Planes: " & .ColorPlanes
        s = s & "  Palette size: " & .PaletteSize & sCrLf
        s = s & "Brushes: " & .BrushCount
        s = s & "  Pens: " & .PenCount
        s = s & "  Fonts: " & .FontCount
        s = s & "  Colors: " & .ColorCount & sCrLf
        s = s & "Transparent blits: " & .TransparentBlt & sCrLf
        s = s & "Aspect: X=" & .XAspect & ", Y=" & .YAspect & ", XY=" & .XYAspect & sCrLf
        
        Dim af As Integer
        s = s & "Raster: "
        af = .RasterCapability
        If af And RC_BITBLT Then s = s & "BitBlt "
        If af And RC_BITMAP64 Then s = s & "BigBitmaps "
        If af And RC_FLOODFILL Then s = s & "FloodFill "
        If af And RC_PALETTE Then s = s & "Palette "
        If af And RC_STRETCHBLT Then s = s & "StretchBlt "
        If .TransparentBlt Then s = s & "TransparentBlt "
        s = s & sCrLf
        
        s = s & "Curves: "
        af = .CurveCapability
        If af And CC_CIRCLES Then s = s & "Circles "
        If af And CC_PIE Then s = s & "Pie"
        If af And CC_CHORD Then s = s & "Chord "
        If af And CC_ELLIPSES Then s = s & "Ellipses "
        If af And CC_ROUNDRECT Then s = s & "RoundRect "
        s = s & sCrLf
        
        s = s & "Lines: "
        af = .LineCapability
        If af And LC_POLYLINE Then s = s & "PolyLine "
        If af And LC_MARKER Then s = s & "Marker "
        If af And LC_POLYMARKER Then s = s & "PolyMarker "
        s = s & sCrLf
        
        s = s & "Polygons: "
        af = .PolygonCapability
        If af And PC_POLYGON Then s = s & "Polygon "
        If af And PC_RECTANGLE Then s = s & "Rectangle "
        If af And PC_WINDPOLYGON Then s = s & "WindPolygon "
        If af And PC_SCANLINE Then s = s & "ScanLine "
        s = s & sCrLf
        
        s = s & "Text: "
        af = .TextCapability
        If af And TC_CR_90 Then s = s & "Rotate 90"
        If af And TC_CR_ANY Then s = s & "RotateAny "
        If af And TC_IA_ABLE Then s = s & "Italic "
        If af And TC_UA_ABLE Then s = s & "Underline "
        If af And TC_SO_ABLE Then s = s & "StrikeOut "
        If af And TC_RA_ABLE Then s = s & "Raster "
        If af And TC_VA_ABLE Then s = s & "Vector "
        s = s & sCrLf
               
    End With
    ShowVideo = s
End Function
