Attribute VB_Name = "MButterFly"
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

' This name and these arguments are required by About form
Sub AnimateMe(canvas As Object, fStop As Boolean)
    ButterFly canvas, fStop
End Sub

Sub ButterFly(canvas As Object, fStop As Boolean)

    Const PI = 3.1415

    Dim x As Single, y As Single, theta As Single
    Dim xx As Single, yy As Single, r As Single
    Dim mulxy As Single, addxy As Single
    Dim powr As Single, divt As Single
    Dim mult As Single, mulc As Single
    Dim incr As Single, muloop As Single
    Dim f As Boolean, clr As Long
      
    Randomize
    ' Initialize variables
    mulxy = 24#     ' Controls size
    powr = 5#       ' Controls some aspects of shape
    divt = 40#      ' Controls density
    mult = 4#       ' Helps make butterfly shape
    mulc = 2#       ' Helps make butterfly shape
    incr = 0.05     ' Controls roundness
    muloop = 50#    ' Controls iterations and density

    ' Make it square
    If canvas.Width < canvas.Height Then
        canvas.Width = canvas.Height
    Else
        canvas.Height = canvas.Width
    End If
    ' Set coordinate system
    canvas.ScaleLeft = -100#
    canvas.ScaleTop = -110#
    canvas.ScaleWidth = 200#
    canvas.ScaleHeight = 200#

    Do While Not fStop
        ' Draw in random color or erase with background
        f = Not f
        If f Then
            clr = QBColor(GetRandom(1, 15))
        Else
            clr = canvas.BackColor
        End If
        ' Draw shape
        For theta = 0# To muloop * PI Step incr
            
            r = Exp(Cos(theta)) - _
                mulc * Cos(mult * theta) + _
                Sin(theta / divt) ^ powr
            x = r * Sin(theta)
            y = r * Cos(theta)
            xx = -((x * mulxy) + addxy)
            yy = -((y * mulxy) + addxy)
            If theta = 0# Then
               ' Move to center without drawing
               canvas.CurrentX = xx
               canvas.CurrentY = yy
            Else
                canvas.Line -(xx, yy), clr
            End If
            theta = theta + incr
            DoEvents
            If fStop Then Exit Sub
        Next
    Loop
        
End Sub
