VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CSysMenu"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

''@B CSysMenu
Private procOld As Long
Private hWnd ' As SysInt
Private cb As CallBack

Function WindowProc(ByVal hWndA, ByVal iMsg, ByVal wParam, _
                    ByVal lParam As Long) As Long
    ' Handle messages
    Select Case iMsg
    Case WM_SYSCOMMAND
        ' Handle menu items
        Select Case wParam
        Case IDM_ABOUT
            MsgBox "Callback Server Test"
            WindowProc = 0
            Exit Function
        End Select
    End Select
    ' Let old window procedure handle other messages
    WindowProc = CallWindowProc(procOld, hWndA, iMsg, wParam, lParam)
End Function

Public Function Create(ByVal hWndA As Long) As Boolean
    ' Subclass window
    If IsWindowLocal(hWndA) Then
        Destroy
        procOld = SetWindowLong(hWndA, GWL_WNDPROC, cb.ProcAddress)
        ' Required to prevent crashes in break mode
        cb.DebugProc = procOld
        If procOld Then
            hWnd = hWndA
            Create = True
        End If
    End If
End Function

Public Sub Destroy()
    If procOld Then
        ' Unsubclass
        SetWindowLong hWnd, GWL_WNDPROC, procOld
        procOld = 0: hWnd = 0
    End If
End Sub

Private Sub Class_Initialize()
    Set cb = NewCallBack(CBType_WNDPROC, Me, True)
End Sub

Private Sub Class_Terminate()
    Destroy
End Sub
''@E CSysMenu

''@B IsWindowLocal
Private Function IsWindowLocal(ByVal hWnd As Long) As Boolean
#If Win32 Then
    Dim idWnd As Long
    Call GetWindowThreadProcessId(hWnd, idWnd)
    IsWindowLocal = (idWnd = GetCurrentProcessId())
#Else
    IsWindowLocal = True
#End If
End Function
''@E IsWindowLocal
'

