VERSION 4.00
Begin VB.Form FFun 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Fun 'n Games"
   ClientHeight    =   6630
   ClientLeft      =   1080
   ClientTop       =   1545
   ClientWidth     =   6690
   ClipControls    =   0   'False
   FillColor       =   &H00FF00FF&
   BeginProperty Font 
      name            =   "MS Sans Serif"
      charset         =   0
      weight          =   700
      size            =   8.25
      underline       =   0   'False
      italic          =   0   'False
      strikethrough   =   0   'False
   EndProperty
   Height          =   7035
   Left            =   1020
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   6630
   ScaleWidth      =   6690
   Top             =   1200
   Width           =   6810
   Begin VB.CommandButton cmdSpiralBmp 
      Caption         =   "Spiral Bitmap"
      Height          =   375
      Left            =   4980
      TabIndex        =   14
      Top             =   585
      Width           =   1575
   End
   Begin VB.CheckBox chkClip 
      Caption         =   "Clip Controls"
      Height          =   285
      Left            =   4980
      TabIndex        =   13
      Top             =   6240
      Value           =   1  'Checked
      Width           =   1575
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear Surface"
      Height          =   375
      Left            =   4980
      TabIndex        =   12
      Top             =   3945
      Width           =   1575
   End
   Begin VB.PictureBox pbAniBmp 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   780
      Left            =   1470
      ScaleHeight     =   780
      ScaleWidth      =   675
      TabIndex        =   11
      Top             =   6960
      Visible         =   0   'False
      Width           =   675
   End
   Begin VB.CommandButton cmdLargeBmp 
      Caption         =   "Large"
      Height          =   360
      Left            =   5580
      TabIndex        =   10
      Top             =   5310
      Width           =   945
   End
   Begin VB.CommandButton cmdAniBmp 
      Caption         =   "Animate"
      Height          =   360
      Left            =   5595
      TabIndex        =   9
      Top             =   5760
      Width           =   945
   End
   Begin VB.CommandButton cmdSmallBmp 
      Caption         =   "Small"
      Height          =   360
      Left            =   5580
      TabIndex        =   8
      Top             =   4905
      Width           =   945
   End
   Begin VB.CommandButton cmdAnimate 
      Caption         =   "&Animate"
      Height          =   375
      Left            =   4980
      TabIndex        =   7
      Top             =   1065
      Width           =   1575
   End
   Begin VB.CommandButton cmdColor 
      Caption         =   "Set Color"
      Height          =   375
      Left            =   4980
      TabIndex        =   6
      Top             =   2025
      Width           =   1575
   End
   Begin VB.CommandButton cmdStar 
      Caption         =   "Stars"
      Height          =   375
      Left            =   4980
      TabIndex        =   5
      Top             =   1545
      Width           =   1575
   End
   Begin VB.CommandButton cmdSort 
      Caption         =   "Sort Cards"
      Height          =   375
      Left            =   4980
      TabIndex        =   4
      Top             =   2985
      Width           =   1575
   End
   Begin VB.Timer tmrAnimate 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   240
      Top             =   6885
   End
   Begin VB.CommandButton cmdBack 
      Caption         =   "Card Backs"
      Height          =   375
      Left            =   4980
      TabIndex        =   3
      Top             =   3465
      Width           =   1575
   End
   Begin VB.CommandButton cmdShuffle 
      Caption         =   "Shuffle Cards"
      Height          =   375
      Left            =   4980
      TabIndex        =   2
      Top             =   2505
      Width           =   1575
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   375
      Left            =   4980
      TabIndex        =   1
      Top             =   4425
      Width           =   1575
   End
   Begin VB.CommandButton cmdBmpSpiral 
      BackColor       =   &H00FFFFFF&
      Caption         =   "Bitmap Spiral"
      Height          =   375
      Left            =   4995
      TabIndex        =   0
      Top             =   105
      Width           =   1575
   End
   Begin VB.Image imgAniBmp 
      BorderStyle     =   1  'Fixed Single
      Height          =   390
      Left            =   4995
      Picture         =   "FUN.frx":0000
      Stretch         =   -1  'True
      Top             =   5745
      Width           =   450
   End
   Begin VB.Image imgLargeBmp 
      BorderStyle     =   1  'Fixed Single
      Height          =   390
      Left            =   4995
      Picture         =   "FUN.frx":03CA
      Stretch         =   -1  'True
      Top             =   5295
      Width           =   450
   End
   Begin VB.Image imgSmallBmp 
      BorderStyle     =   1  'Fixed Single
      Height          =   390
      Left            =   4995
      Picture         =   "FUN.frx":1080C
      Stretch         =   -1  'True
      Top             =   4860
      Width           =   450
   End
   Begin VB.Image imgBig 
      Height          =   3840
      Left            =   9555
      Picture         =   "FUN.frx":10A8E
      Top             =   2565
      Visible         =   0   'False
      Width           =   3840
   End
   Begin VB.Image imgLittle 
      Height          =   480
      Left            =   12300
      Picture         =   "FUN.frx":18B10
      Top             =   1050
      Visible         =   0   'False
      Width           =   480
   End
End
Attribute VB_Name = "FFun"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

Private dxCard ' As SysInt
Private dyCard ' As SysInt

Private ordScale As Integer
Private xInc As Single, yInc As Single
Private xMove As Single, yMove As Single
Private aCards(0 To 51) As Variant
''@B pgBitmap
Private pgBitmap As New CPictureGlass
''@E pgBitmap

Const ordNone = 0
Const ordBacks = 1
Const ordBitmap = 2
Private ordAnimate As Integer

Private Sub Form_Load()
    
    Randomize
    ' Initialize CARDS library and array
    If cdtInit(dxCard, dyCard) = False Then
        cmdSort.Enabled = False
        cmdShuffle.Enabled = False
        cmdBack.Enabled = False
    Else
        Dim i As Integer
        For i = 0 To 51
            aCards(i) = i
        Next
        ShuffleArray aCards()
    End If
    pbAniBmp.Picture = imgAniBmp.Picture
    SetClipControls Me.hWnd, chkClip.Value = vbChecked
    
End Sub

Private Sub chkClip_Click()
    SetClipControls Me.hWnd, chkClip.Value = vbChecked
End Sub

''@B cmdAnimate
Private Sub cmdAnimate_Click()
    If cmdAnimate.Caption = "&Animate" Then
        With pgBitmap
            .Create pbAniBmp
            .Visible = False
            ' Constant controls pace, sign controls direction
            xInc = .Width * 0.05
            yInc = -.Height * 0.05
            ' Start in center
            .Left = (Width / 2) - (.Width / 2)
            .Top = (Height / 2) - (.Height / 2)
            .Visible = True
        End With
        SetTimer ordBitmap
        cmdAnimate.Caption = "Stop &Animate"
    Else
        pgBitmap.Visible = False
        SetTimer ordNone
        cmdAnimate.Caption = "&Animate"
    End If
End Sub
''@E cmdAnimate

''@B cmdBack_Click
Private Sub cmdBack_Click()
    ordScale = Me.ScaleMode: Me.ScaleMode = vbPixels
    SetTimer ordBacks
    Me.Cls
    Dim x As Integer, y As Integer, ordBack As Integer
    ordBack = ordCrossHatch  ' First card back
    ' Draw cards in 4 by 4 grid
    For x = 0 To 3
        For y = 0 To 3
            Call cdtDraw(Me.hDC, _
                         (dxCard * 0.1) + (x * dxCard * 1.1), _
                         (dyCard * 0.1) + (y * dyCard * 1.1), _
                         ordBack, ordBacks, QBColor(GetRandom(0, 15)))
            ordBack = ordBack + 1
        Next
    Next
    Me.ScaleMode = ordScale
End Sub
''@E cmdBack_Click

' Secret undocumented command for animating card backs a click at a time
Private Sub cmdBack_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = 2 Then
        Static f As Boolean
        If f = False Then
            cmdBack_Click
            f = True
            SetTimer ordNone
        End If
        AnimateBacks
    End If
    
End Sub

Private Sub cmdBmpSpiral_Click()
    SetTimer ordNone
    ''@B CallBmpSpiral
    BmpSpiral imgSmallBmp.Picture, Me
    ''@E CallBmpSpiral
    imgSmallBmp.Refresh
    imgLargeBmp.Refresh
    imgAniBmp.Refresh
End Sub

Private Sub cmdSpiralBmp_Click()
    SetTimer ordNone
    ''@B CallSpiralBmp
    Dim x, y ' As SysInt
    x = ((Width - (cmdSpiralBmp.Width * 1.2)) / 2) - (ScaleX(imgLargeBmp.Picture.Width) / 2)
    y = ((Height - (cmdSpiralBmp.Height * 1.2)) / 2) - (ScaleY(imgLargeBmp.Picture.Height) / 2)
    SpiralBmp imgLargeBmp.Picture, Me, x, y
    ''@E CallSpiralBmp
End Sub

Private Sub cmdClear_Click()
    SetTimer ordNone
    Cls
End Sub

Private Sub cmdExit_Click()
    Unload Me
End Sub

Private Sub cmdSmallBmp_Click()
    Call FillPicture(imgSmallBmp)
    cmdClear_Click
End Sub

Private Sub cmdLargeBmp_Click()
    Call FillPicture(imgLargeBmp)
    cmdClear_Click
End Sub

Private Sub cmdAniBmp_Click()
    Call FillPicture(imgAniBmp)
    pbAniBmp.Picture = imgAniBmp.Picture
    cmdClear_Click
End Sub

Private Sub cmdColor_Click()
    Dim pf As New FGetColor
    Static clrLast As Long
    If clrLast <> 0& Then pf.Color = clrLast
    pf.Show vbModal
    clrLast = pf.Color
    Me.BackColor = clrLast
    chkClip.BackColor = clrLast
    
End Sub

Private Sub cmdStar_Click()
    SetTimer ordNone
    Dim i As Integer, xMid, yMid, dxyRadius ' As SysInt
    ''@B CallStar
    For i = 1 To GetRandom(5, 20)
        dxyRadius = GetRandom(Height / 8, Height / 4)
        xMid = GetRandom(1, Width): yMid = GetRandom(1, Height)
        Star xMid, yMid, dxyRadius, vbBlack, _
             QBColor(GetRandom(1, 15)), QBColor(GetRandom(1, 15)), Me
    Next
    ''@E CallStar
    imgSmallBmp.Refresh
    imgLargeBmp.Refresh
    imgAniBmp.Refresh
End Sub


Private Function FillPicture(pic As Control) As Boolean
    Dim opfile As New FOpenPicFile
    With opfile
        .InitDir = "c:\windows"
        .FilterType = opicBitmap
        .Show vbModal
        If .FileName <> sEmpty And .PicType = vbPicTypeBitmap Then
            pic.Picture = LoadPicture(.FileName)
        End If
    End With
    Set opfile = Nothing
End Function

Private Sub cmdShuffle_Click()
    SetTimer ordNone
    ordScale = Me.ScaleMode: Me.ScaleMode = vbPixels
    ShuffleArray aCards()
    ShowCards aCards()
    Me.ScaleMode = ordScale
End Sub

Private Sub cmdSort_Click()
    SetTimer ordNone
    ordScale = Me.ScaleMode: Me.ScaleMode = vbPixels
    SortArray aCards(), 0, 51
    ShowCards aCards()
    Me.ScaleMode = ordScale
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim f As Integer
    If dxCard Then Call cdtTerm
End Sub

Private Sub imgAniBmp_Click()
    cmdAniBmp_Click
End Sub

Private Sub imgLargeBmp_Click()
    cmdLargeBmp_Click
End Sub

Private Sub imgSmallBmp_Click()
    cmdSmallBmp_Click
End Sub

Private Sub tmrAnimate_Timer()

    Select Case ordAnimate
    Case ordNone
        Exit Sub
    Case ordBacks
        AnimateBacks
    Case ordBitmap
        AnimateBitmap
    End Select

End Sub

''@B AnimateBacks
Sub AnimateBacks()
    Static x As Integer, y As Integer
    Static ordBack As Integer, iState As Integer
    ' Adjust variables
    If ordBack < ordCrossHatch Or ordBack > ordO Then
        ordBack = ordCrossHatch
        x = 0: y = 0
    End If
    If x = 4 Then x = 0
    If y = 4 Then y = 0: x = x + 1
    ' Save scale mode and change to pixels
    ordScale = Me.ScaleMode: Me.ScaleMode = vbPixels
    Select Case ordBack
    Case ordCrossHatch
        ' Change color of crosshatch
        Call cdtDraw(Me.hDC, _
                     (dxCard * 0.1) + (x * dxCard * 1.1), _
                     (dyCard * 0.1) + (y * dyCard * 1.1), _
                     ordBack, ordBacks, QBColor(GetRandom(0, 15)))
    Case ordRobot, ordCastle, ordBeach, ordCardHand
        ' Step through animation states
        If cdtAnimate(Me.hDC, ordBack, _
                      (dxCard * 0.1) + (x * dxCard * 1.1), _
                      (dyCard * 0.1) + (y * dyCard * 1.1), iState) Then
            iState = iState + 1
            Exit Sub    ' Don't move to next card until final state
        End If
        iState = 0
    ' Case Else
        ' Ignore other cards
    End Select
    ' Move to next card
    Me.ScaleMode = ordScale
    ordBack = ordBack + 1
    y = y + 1
End Sub
''@E AnimateBacks

''@B AnimateBitmap
Private Sub AnimateBitmap()
    With pgBitmap
        If .Left + .Width > Me.ScaleWidth Then xInc = -xInc
        If .Left <= Abs(xInc) Then xInc = -xInc
        If .Top + .Height > Me.ScaleHeight Then yInc = -yInc
        If .Top <= Abs(yInc) Then yInc = -yInc
        .Move .Left + xInc, .Top + yInc
    End With
End Sub
''@E AnimateBitmap

Private Sub SetTimer(ordAnimateA As Integer)
    ordAnimate = ordAnimateA
    Select Case ordAnimate
    Case ordNone
        tmrAnimate.Enabled = False
        Me.ScaleMode = vbTwips
    Case ordBitmap
        tmrAnimate.Interval = 10
        tmrAnimate.Enabled = True
    Case ordBacks
        tmrAnimate.Interval = 100
        tmrAnimate.Enabled = True
    End Select
End Sub

Private Sub ShowCards(aCards() As Variant)
    Dim iSuit As Integer, iCard As Integer
    
    For iCard = 0 To 12
        For iSuit = 0 To 3
            Call cdtDraw(Me.hDC, _
                         (dxCard * 0.3) + (iSuit * dxCard), _
                         (dyCard * 0.1) + iCard * (dyCard / 3.7), _
                         aCards(iSuit + (iCard * 4)), 0, 0&)
        Next
    Next
End Sub
    
Sub SetClipControls(hWnd, f As Boolean)
    ' You want to do this:
    'Me.ClipControls = f
    ' But Visual Basic won't let you; do this instead:
    ChangeStyleBit hWnd, f, WS_CLIPCHILDREN
End Sub
