VERSION 4.00
Begin VB.Form FHardCore 
   AutoRedraw      =   -1  'True
   Caption         =   "Hard Core Samples"
   ClientHeight    =   5640
   ClientLeft      =   1095
   ClientTop       =   1890
   ClientWidth     =   9435
   BeginProperty Font 
      name            =   "MS Sans Serif"
      charset         =   1
      weight          =   700
      size            =   8.25
      underline       =   0   'False
      italic          =   0   'False
      strikethrough   =   0   'False
   EndProperty
   Height          =   6330
   Icon            =   "HARDCORE.frx":0000
   Left            =   1035
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   5640
   ScaleWidth      =   9435
   Top             =   1260
   Width           =   9555
   Begin VB.CommandButton cmdExe 
      Caption         =   "Exe Type"
      Height          =   495
      Left            =   240
      TabIndex        =   11
      Top             =   2520
      Width           =   975
   End
   Begin VB.CommandButton cmdColor 
      Caption         =   "Set Color"
      Height          =   495
      Left            =   240
      TabIndex        =   10
      Top             =   4320
      Width           =   975
   End
   Begin VB.PictureBox pbColor 
      Height          =   735
      Left            =   1440
      ScaleHeight     =   705
      ScaleWidth      =   2505
      TabIndex        =   9
      Top             =   120
      Width           =   2535
   End
   Begin VB.CommandButton cmdMenus 
      Caption         =   "Menus"
      Height          =   495
      Left            =   240
      TabIndex        =   8
      Top             =   3720
      Width           =   975
   End
   Begin VB.CommandButton cmdOpen 
      Caption         =   "Open File"
      Height          =   495
      Left            =   240
      TabIndex        =   7
      Top             =   3120
      Width           =   975
   End
   Begin VB.PictureBox pbBitmap 
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   855
      Left            =   6900
      ScaleHeight     =   855
      ScaleWidth      =   885
      TabIndex        =   6
      Top             =   45
      Width           =   885
   End
   Begin VB.CommandButton cmdCallInt 
      Caption         =   "CallInt"
      Height          =   495
      Left            =   240
      TabIndex        =   5
      Top             =   1920
      Width           =   975
   End
   Begin VB.CommandButton cmdBlob 
      Caption         =   "Blob"
      Height          =   495
      Left            =   240
      TabIndex        =   4
      Top             =   1320
      Width           =   975
   End
   Begin VB.TextBox txtTest 
      BeginProperty Font 
         name            =   "Courier"
         charset         =   1
         weight          =   700
         size            =   9.75
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   4335
      Left            =   1440
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   3
      Top             =   1080
      Width           =   7815
   End
   Begin VB.CommandButton cmdWin32 
      Caption         =   "Win32"
      Height          =   495
      Left            =   240
      TabIndex        =   2
      Top             =   735
      Width           =   975
   End
   Begin VB.CommandButton cmdDLL 
      Caption         =   "Bits"
      Height          =   495
      Left            =   240
      TabIndex        =   1
      Top             =   120
      Width           =   975
   End
   Begin VB.CommandButton btnExit 
      Caption         =   "Exit"
      Height          =   495
      Left            =   240
      TabIndex        =   0
      Top             =   4920
      Width           =   975
   End
   Begin MSComDlg.CommonDialog dlgOpenPic 
      Left            =   4140
      Top             =   105
      _version        =   65536
      _extentx        =   847
      _extenty        =   847
      _stockprops     =   0
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuOpen 
         Caption         =   "&Open..."
      End
      Begin VB.Menu mnuDead 
         Caption         =   "&Dead"
         Enabled         =   0   'False
      End
      Begin VB.Menu mnuGone 
         Caption         =   "&Gone"
         Visible         =   0   'False
      End
      Begin VB.Menu mnuSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu mnuCut 
         Caption         =   "Cu&t"
         Shortcut        =   ^X
      End
      Begin VB.Menu mnuPaste 
         Caption         =   "&Paste"
         Shortcut        =   ^V
      End
      Begin VB.Menu mnuView 
         Caption         =   "&View"
         WindowList      =   -1  'True
         Begin VB.Menu mnuSome 
            Caption         =   "&Some"
         End
         Begin VB.Menu mnuAll 
            Caption         =   "&All"
         End
      End
      Begin VB.Menu mnuCheck 
         Caption         =   "&Check"
         Checked         =   -1  'True
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuContents 
         Caption         =   "&Contents"
      End
      Begin VB.Menu mnuAbout 
         Caption         =   "&About..."
      End
   End
End
Attribute VB_Name = "FHardCore"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

Private Type ChunkType
    abData(0 To 255) As Byte
End Type
    
Private Type TestType
    lp As String
    l As Long
End Type

''@B pal
Private pal As New CGetColor
''@E pal
Private fCreated As Boolean

Private aEmpty(0) As Variant

Private hWndTB As Integer
Private hWndSB As Integer

Const SB_HORZ = 0
Const SB_VERT = 1
Const SB_CTL = 2

Private Sub btnExit_Click()
    Unload Me
End Sub

Private Sub cmdBlob_Click()
    Dim s As String, i As Integer, ab() As Byte, ab2() As Byte
    Dim sMsg As String
    
    sMsg = sMsg & "Assign string to byte array and byte string" & sCrLf
    StrToBytes ab, "1234567890"
    s = ab
    sMsg = sMsg & "Byte string as byte array: " & BytesToStr(ab) & sCrLf
    sMsg = sMsg & "Length: " & LenBytes(ab) & sCrLf
    sMsg = sMsg & "Byte string ss string: " & StrBToStr(s) & sCrLf
    sMsg = sMsg & "Length: " & LenB(s) & sCrLfCrLf

    sMsg = sMsg & "Read and insert numbers from byte array" & sCrLf
    sMsg = sMsg & "Word (from string) at &H4: &H" & Hex(WordFromStringB(s, 4)) & sCrLf
    sMsg = sMsg & "Word (from bytes) at &H4: &H" & Hex(BytesToWord(ab, 4)) & sCrLf
    sMsg = sMsg & "DWord at &H4: &H" & Hex(BytesToDWord(ab, 4)) & sCrLf
    BytesFromWord &H7372, ab, 4
    sMsg = sMsg & "Insert &H7372 at &H4: " & BytesToStr(ab) & sCrLf
    BytesFromDWord &H65666768, ab, 4
    sMsg = sMsg & "Insert &H65666768 at &H4: " & BytesToStr(ab) & sCrLf
    sMsg = sMsg & "Word at &H4: &H" & Hex(BytesToWord(ab, 4)) & sCrLf
    sMsg = sMsg & "DWord at &H4: &H" & Hex(BytesToDWord(ab, 4)) & sCrLfCrLf

    sMsg = sMsg & "Extract and insert strings on byte array" & sCrLf
    StrToBytes ab, "1234567890"
    s = ab
    sMsg = sMsg & "Left 3: " & LeftBytes(ab, 3) & sCrLf
    sMsg = sMsg & "Right 3: " & RightBytes(ab, 3) & sCrLf
    sMsg = sMsg & "From &H5: " & MidBytes(ab, 5) & sCrLf
    sMsg = sMsg & "From &H5 length 2: " & MidBytes(ab, 5, 2) & sCrLfCrLf
    InsBytes "ABC", ab, 2
    sMsg = sMsg & "Insert 'ABC' at &h2: " & BytesToStr(ab) & sCrLf
    InsBytes "ABC", ab, 4, 4
    sMsg = sMsg & "Insert 'ABC' at &H4 in field of 4: " & BytesToStr(ab) & sCrLf
    sMsg = sMsg & "From &H4 length 5 to null: " & MidBytes(ab, 4, 5, True) & sCrLf
    sMsg = sMsg & "From &H4 length 5: " & MidBytes(ab, 4, 5) & sCrLfCrLf
    FillBytes ab, Asc(" "), 5, 4
    sMsg = sMsg & "Insert spaces at &H5 in field of 4: " & BytesToStr(ab) & sCrLfCrLf

    ' Test asserts
    'InsBytes "ABC", ab, 9
    'sMsg = sMsg & "Insert 'ABC' at position 9: " & BytesToStr(ab) & sCrLf
    'InsBytes "ABC", ab, 8, 4
    'sMsg = sMsg & "Insert 'ABC' at position 8 in field of 4: " & BytesToStr(ab) & sCrLf
    'FillBytes ab, Asc(" "), 7, 4
    'sMsg = sMsg & "Insert spaces at position 7 in field of 4: " & BytesToStr(ab) & sCrLf
    
    sMsg = sMsg & "Find string in byte array" & sCrLf
    StrToBytes ab, "1234567890"
    s = ab
    StrToBytes ab2, "56"
    sMsg = sMsg & "56 at position: " & InStrB(ab, ab2) & sCrLf
    sMsg = sMsg & "56 at position: " & InStrB(s, ab2) & sCrLf

    StrToBytes ab, "1234567890"
    s = ab
    sMsg = sMsg & "Hex dump of byte arrays, byte strings, strings" & sCrLf
    sMsg = sMsg & "Dump byte array: " & sCrLf & HexDump(ab, False) & sCrLf
    sMsg = sMsg & "Dump byte string: " & sCrLf & HexDumpB(s, False) & sCrLf
    sMsg = sMsg & "Dump string: " & sCrLf & HexDumpS(s, False) & sCrLfCrLf
    
    sMsg = sMsg & "ANSI characters that don't match Unicode versions" & sCrLf
    For i = 0 To 255
        If AscW(Chr$(i)) <> i Then
            sMsg = sMsg & "ANSI: &H" & Hex(i, 2) & sTab
            sMsg = sMsg & "  Unicode: &H" & Hex(AscW(Chr$(i)), 4) & sTab
            sMsg = sMsg & "  Character: " & Chr$(i) & sCrLf
        End If
    Next
    sMsg = sMsg & sCrLf

    ' Open binary file for processing
    Dim sBinFile As String, nBinFile As Integer
    Dim sBin As String, abBin() As Byte
    sBinFile = "mem.pif"
    ''@B GetBinFile
    nBinFile = FreeFile
    Open sBinFile For Binary Access Read Write Lock Write As #nBinFile
    'ReDim abBin(FileLen(sBinFile))
    ReDim abBin(LOF(nBinFile))
    Get #nBinFile, 1, abBin
    sBin = abBin
    ''@E GetBinFile
    sMsg = sMsg & "Open file and process as byte string or byte array" & sCrLf
    sMsg = sMsg & "Dump first 20 byte characters: " & sCrLf
    sMsg = sMsg & HexDumpB(MidB$(sBin, 1, 20)) & sCrLf
    sMsg = sMsg & "Dump first 20 bytes: " & sCrLf
    sMsg = sMsg & HexDump(MidBytes(abBin, 0, 20)) & sCrLf
    ''@B PutBinFile
    abBin = sBin
    Put #nBinFile, 1, abBin
    Close #nBinFile
    ''@E PutBinFile

    BugMessage sMsg
    txtTest.Text = sMsg
End Sub

Private Sub cmdCallInt_Click()
    
    Dim f As Integer, s As String
    Dim fVerifyOld As Integer, fVerifyNew As Integer
    
#If Win32 Then
    s = "No 32-bit Interrupt Function"
#Else
    ' Get verify state and save it
    fVerifyOld = GetVerify()
    s = "Original verify state: " & fVerifyOld & sCrLf
    
    ' Toggle verify state
    fVerifyNew = Not fVerifyOld
    SetVerify fVerifyNew

    ' Get verify state
    fVerifyNew = GetVerify()
    s = s & "Verify state after toggle: " & fVerifyNew & sCrLf

    ' Restore verify state
    SetVerify fVerifyOld

    ' Confirm restore
    fVerifyNew = GetVerify()
    s = s & "Verify state after restore: " & fVerifyNew & sCrLf

    Dim sMachine As String, iNetBios As Integer
    iNetBios = GetMachineName(sMachine)
    If iNetBios < 0 Then
        If iNetBios = -1 Then
            s = s & "Network not running" & sCrLf
        Else
            s = s & "Network not installed" & sCrLf
        End If
    Else
        s = s & "Computer name: " & sMachine & sCrLf
        s = s & "NETBIOS number: " & iNetBios & sCrLf
    End If
    
    #End If
    BugMessage s
    txtTest.Text = s
    
End Sub

Private Sub cmdDLL_Click()
    Dim dw As Long, w As Integer, r As Single, d As Double
    Dim c As Currency, s As String, i As Integer
    Dim pl As Long, PI As Long, pr As Long, pd As Long
    Dim pc As Long, ps As Long, psz As Long
    Dim sOutput As String
    sOutput = ""

    'DebugBreak

    'w = &HABCD
    w = &HFFFF
    'dw = &HFEDCBA98
    dw = &HFFFF0000
    r = 1.23456789
    d = 9.87654321
    c = 999.99
    s = "Test"

    Dim bHi As Integer, bLo As Integer
    Dim wHi As Integer, wLo As Integer
    Dim wPack  As Integer, dwPack  As Long
    Dim wRShift As Integer, wLShift As Integer
    Dim dwRShift As Long, dwLShift As Long

    sOutput = "VB Versions" & sCrLf
#If 1 Then
    bLo = LoByte(w)
    sOutput = sOutput & "Low byte of word (" & Hex$(w) & "): " & Hex$(bLo) & sCrLf
    bHi = HiByte(w)
    sOutput = sOutput & "High byte of word (" & Hex$(w) & "): " & Hex$(bHi) & sCrLf
    wPack = MakeWord(bLo, bHi)
    sOutput = sOutput & "Packed hi/lo bytes of word: " & Hex$(wPack) & sCrLf
    wLo = LoWord(dw)
    sOutput = sOutput & "Low Word of DWord (" & Hex$(dw) & "): " & Hex$(wLo) & sCrLf
    wHi = HiWord(dw)
    sOutput = sOutput & "High Word of DWord (" & Hex$(dw) & "): " & Hex$(wHi) & sCrLf
    dwPack = MakeDWord(wHi, wLo)
    sOutput = sOutput & "Packed hi/lo Word of DWord: " & Hex$(dwPack) & sCrLf
#End If

    
#If 1 Then
    sOutput = sOutput & "Word shifted right" & sCrLf
    For i = 0 To 15
        sOutput = sOutput & Hex$(RShiftWord(w, i)) & "  "
    Next
    sOutput = sOutput & sCrLf
#End If
#If 1 Then
    sOutput = sOutput & "Word shifted left" & sCrLf
    For i = 0 To 15
        sOutput = sOutput & Hex$(LShiftWord(w, i)) & "  "
    Next
    sOutput = sOutput & sCrLf
#End If
#If 1 Then
    sOutput = sOutput & "DWord shifted right C" & sCrLf
    For i = 0 To 31
        sOutput = sOutput & Hex$(RShiftDWord(dw, i)) & "  "
    Next
    sOutput = sOutput & sCrLf
#End If
#If 1 Then
    sOutput = sOutput & "DWord shifted left C" & sCrLf
    For i = 0 To 31
        sOutput = sOutput & Hex$(LShiftDWord(dw, i)) & "  "
    Next
    sOutput = sOutput & sCrLf
#End If
    txtTest.Text = sOutput

End Sub

Private Sub cmdExe_Click()
    Const sFilter = "EXE Files|*.exe|" & _
                    "DLL Files(*.DLL;*.OCX)|*.dll;*.ocx|" & _
                    "All Files (*.*)|*.*"
    Dim sFile As String, f As Boolean, ordExe As Integer
    f = VBGetOpenFileName( _
        vFileName:=sFile, _
        vFlags:=cdlOFNFileMustExist Or cdlOFNHideReadOnly, _
        vFilter:=sFilter) ' *.bmp;*.dib;*.ico;*.wmf;*.cur
        'vInitDir:="c:\windows",
    If f And sFile <> sEmpty Then ordExe = ExeType(sFile)

    Dim s As String
    Select Case ordExe
    ' Valid Exe types (for ExeType function)
    Case ordMSDOS
        s = "MS-DOS Program"
    Case ordWin16
        s = "Windows 3.x Program"
    Case ordOS2_1
        s = "OS/2 1.x Program"
    Case ordWin32
        s = "Win32 Program (Windows NT or Windows 95)"
    Case ordWin32Console
        s = "Win32 Console Program (Windows NT or Windows 95)"
    Case ordDOSUnknown   ' Probably DOS extended
        s = "Unknown MS-DOS Program (probably DOS-extended"
    
    ' Unknown - could still be .BAT, .CMD, .COM, or .PIF
    Case ordNotExe
        s = "Not a known EXE Program (could still be BAT, CMD, COM, or PIF)"
    
    ' Errors
    Case errNoFile
        s = "No file found"
    Case errOS2_2
        s = "OS/2 2.x executable"
    Case errWinOS2DLL
        s = "OS/2 DLL"
    Case errNEUnknown
        s = "Unknown executable in NE format"
    Case errNTNonIntel
        s = "Windows NT executable for non-Intel platform"
    Case errWin32DLL
        s = "Win32 DLL (Windows NT or Windows 95)"
    End Select
    MsgBox UCase$(sFile) & " file: " & s
End Sub

Private Sub cmdMenus_Click()
    ''@B CreateMenu
    Dim menu As New CMenuList, ritem As CMenuItem
    Call menu.Create(Me.hWnd)
    ''@E CreateMenu
    ''@B WalkMenu
    menu.Walk
    ''@E WalkMenu
    ''@B FindMenu
    Dim s As String
    s = InputBox("Enter menu item to find: ")
    If Not menu.Find(s, ritem) Then
        MsgBox "Can't find item: " & s
        Exit Sub
    End If
    ''@E FindMenu
    ''@B PropMenu
    With ritem
        s = "Name: " & .Name & sCrLf
        s = s & "Text: " & .Text & sCrLf & "State: "
        s = s & IIf(.Disabled, "Disabled ", sEmpty)
        s = s & IIf(.Checked, "Checked ", sEmpty)
        s = s & IIf(.Grayed, "Grayed ", sEmpty)
        s = s & IIf(.Popup, "Popup ", sEmpty) & sCrLf
        txtTest.Text = s
    End With
    ''@E PropMenu
    ''@B ExecMenu
    Call ritem.Execute
    ''@E ExecMenu
    menu.Refresh
    Dim f As Boolean
    If menu.Find("Dead", ritem) Then
        BugMessage ritem.Disabled
        BugMessage ritem.Grayed
        ritem.Text = "&Live"
        BugMessage ritem.Disabled
        BugMessage ritem.Grayed
        ritem.Disabled = False
        BugMessage ritem.Disabled
        BugMessage ritem.Grayed
    ElseIf menu.Find("Live", ritem) Then
        BugMessage ritem.Disabled
        BugMessage ritem.Grayed
        ritem.Text = "&Dead"
        BugMessage ritem.Disabled
        BugMessage ritem.Grayed
        ritem.Disabled = True
        BugMessage ritem.Disabled
        BugMessage ritem.Grayed
    End If

    Dim SysMenu As New CMenuList
    f = SysMenu.Create(Me.hWnd, True)
    SysMenu.Walk
    If WindowState = vbMaximized Then
        f = SysMenu.Find("Restore", ritem)
    Else
        f = SysMenu.Find("Maximize", ritem)
    End If
    'f = sysmenu.Find("Switch To", ritem)
    f = ritem.Execute
        
End Sub

Private Sub cmdOpen_Click()
    Const sFilter = "All Picture Files|*.bmp;*.dib;*.ico;*.wmf;*.cur|" & _
                    "Bitmaps (*.BMP;*.DIB)|*.bmp;*.dib|" & _
                    "Metafiles (*.WMF)|*.wmf|" & _
                    "Icons (*.ICO)|*.ico|" & _
                    "Cursors (*.CUR;*.ICO)|*.cur;*.ico|" & _
                    "All Files (*.*)|*.*"
#Const OpenFile = 1
#If OpenFile = 1 Then
    ''@B VBGetOpenFileNameCall
    Dim sFile As String, f As Boolean
    f = VBGetOpenFileName( _
        vFileName:=sFile, _
        vInitDir:="c:\windows", _
        vFlags:=cdlOFNFileMustExist Or cdlOFNHideReadOnly, _
        vFilter:=sFilter) ' *.bmp;*.dib;*.ico;*.wmf;*.cur
    If f And sFile <> sEmpty Then pbBitmap.Picture = LoadPicture(sFile)
    ''@E VBGetOpenFileNameCall
#ElseIf OpenFile = 2 Then
    ''@B opfileCall
    ''@B SetBmp1
    Dim opfile As New FOpenPicFile
    ''@E SetBmp1
    ''@B SetBmp2
    With opfile
    ''@E SetBmp2
    ''@B SetBmp3
        .InitDir = "c:\windows"
    ''@E SetBmp3
    ''@B SetBmp4
        .Show vbModal
    ''@E SetBmp4
    ''@B SetBmp5
        If .FileName <> sEmpty Then
            pbBitmap.Picture = LoadPicture(.FileName)
        End If
    End With
    ''@E SetBmp5
    ''@B SetBmp6
    Set opfile = Nothing
    ''@E SetBmp6
    ''@E opfileCall
#ElseIf OpenFile = 3 Then
    ''@B dlgOpenPicCall
    With dlgOpenPic
        .InitDir = "c:\windows"
        .Flags = cdlOFNFileMustExist Or cdlOFNHideReadOnly
        .Filter = sFilter ' *.bmp;*.dib;*.ico;*.wmf;*.cur
        .ShowOpen
        If .FileName <> sEmpty Then
            pbBitmap.Picture = LoadPicture(.FileName)
        End If
    End With
    ''@E dlgOpenPicCall
#End If

End Sub



Private Sub cmdWin32_Click()

    Dim i As Integer, s As String, sVal As String
    Dim sName As String, sFullName As String
    Dim c As Long, f As Boolean
    Dim iDir As Long, iBase As Long, iExt As Long
    
    sName = GetTempDir()
    
    ' Test ExistFile
    s = "Test ExistFile" & sCrLf & sCrLf
    sName = Environ$("COMSPEC")
    s = s & "File " & sName & " exists: " & ExistFile(sName) & sCrLf
    sName = "nosuch.txt"
    s = s & "File " & sName & " exists: " & ExistFile(sName) & sCrLf
    
    ' Test GetFullPathName
    s = s & sCrLf & "Test GetFullPathName" & sCrLf & sCrLf
    ''@B GetFullPathName
    Dim sBase As String, pBase As Long
    sFullName = String$(cMaxPath, 0)
    c = GetFullPathName(sName, cMaxPath, sFullName, pBase)
    sFullName = Left$(sFullName, c)
    If c Then
        s = s & "Full name: " & sFullName & sCrLf
    ''@E GetFullPathName
#If Win32 = False Then
        ' Fails 32-bit because pointer is to temporary Unicode string
        sBase = String$(20, 0)
        Call lstrcpyFromLp(sBase, pBase)
        sBase = StrZToStr(sBase)
        s = s & "Name: " & sBase & sCrLf
#End If
    End If
 
    ''@B GetFullPath
    s = s & sCrLf & "Test GetFullPath" & sCrLf & sCrLf
    sFullName = GetFullPath(sName, iDir, iBase, iExt)
    If sFullName <> sEmpty Then
        s = s & "Relative file: " & sName & sCrLf
        s = s & "Full name: " & sFullName & sCrLf
        s = s & "File: " & Mid$(sFullName, iBase) & sCrLf
        s = s & "Extension: " & Mid$(sFullName, iExt) & sCrLf
        s = s & "Base name: " & Mid$(sFullName, iBase, _
                                     iExt - iBase) & sCrLf
        s = s & "Drive: " & Left$(sFullName, iDir - 1) & sCrLf
        s = s & "Directory: " & Mid$(sFullName, iDir, _
                                     iBase - iDir) & sCrLf
        s = s & "Path: " & Left$(sFullName, iBase - 1) & sCrLf
    Else
        s = s & "Invalid name: " & sName
    End If
    ''@E GetFullPath

    ' Test SearchPath
    s = s & sCrLf & "Test SearchPath" & sCrLf & sCrLf
    sName = "vb.hlp"
    sFullName = String$(cMaxPath, 0)
    i = SearchPath(vbNullString, sName, vbNullString, cMaxPath, sFullName, pBase)
    sFullName = Left$(sFullName, i)
    If i Then
        s = s & "File " & sName & " found in: " & sFullName & sCrLf
#If Win32 = False Then
        ' Fails 32-bit because pointer is to temporary Unicode string
        sBase = String$(20, 0)
        Call lstrcpyFromLp(sBase, pBase)
        sBase = StrZToStr(sBase)
        s = s & "Name: " & sBase & sCrLf
#End If
    Else
        s = s & "File " & sName & " not found" & sCrLf
    End If
    
    s = s & sCrLf & "Test SearchDirs" & sCrLf & sCrLf
    ''@B SearchDirs1
    sName = "vb.hlp"
    sFullName = SearchDirs(sEmpty, sName, sEmpty, iDir, iBase, iExt)
    If sFullName <> sEmpty Then
        s = s & "Found file " & sName
        s = s & " in " & sFullName & sCrLf
        s = s & "File: " & Mid$(sFullName, iBase) & sCrLf
        s = s & "Extension: " & Mid$(sFullName, iExt) & sCrLf
        s = s & "Base name: " & Mid$(sFullName, iBase, _
                                     iExt - iBase) & sCrLf
        s = s & "Drive: " & Left$(sFullName, iDir - 1) & sCrLf
        s = s & "Directory: " & Mid$(sFullName, iDir, _
                                     iBase - iDir) & sCrLf
        s = s & "Path: " & Left$(sFullName, iBase - 1) & sCrLf
    Else
        s = s & "File " & sName & " not found" & sCrLf
    End If
    ''@E SearchDirs1

    sName = "hardcore.frm"
    sFullName = SearchDirs(sEmpty, sName, sEmpty, iDir, iBase, iExt)
    If sFullName <> sEmpty Then
        s = s & "File " & sName & " found in: " & sFullName & sCrLf
    Else
        s = s & "File " & sName & " not found" & sCrLf
    End If
    
    sName = "calc.exe"
    sFullName = SearchDirs(sEmpty, sName, sEmpty, iDir, iBase, iExt)
    If sFullName <> sEmpty Then
        s = s & "File " & sName & " found in: " & sFullName & sCrLf
    Else
        s = s & "File " & sName & " not found" & sCrLf
    End If
    
    sName = "gdi.exe"
    sFullName = SearchDirs(sEmpty, sName, sEmpty, iDir, iBase, iExt)
    If sFullName <> sEmpty Then
        s = s & "File " & sName & " found in: " & sFullName & sCrLf
    Else
        s = s & "File " & sName & " not found" & sCrLf
    End If

    sName = "find.exe"
    sFullName = SearchDirs(sEmpty, sName, sEmpty, iDir, iBase, iExt)
    If sFullName <> sEmpty Then
        s = s & "File " & sName & " found in: " & sFullName & sCrLf
    Else
        s = s & "File " & sName & " not found" & sCrLf
    End If

    ''@B SearchDirs2
    sName = Environ("INCLUDE")
    sFullName = SearchDirs(sName, "WINDOWS.H", sEmpty, iDir, iBase, iExt)
    ''@E SearchDirs2
    If sFullName <> sEmpty Then
        s = s & "File found in: " & sFullName & sCrLf
    Else
        s = s & "File not found" & sCrLf
    End If

    ''@B SearchDirs3
    sName = "DEBUG.BAS"
    sFullName = SearchDirs(".", sName, sEmpty, iDir, iBase, iExt)
    ''@E SearchDirs3
    If sFullName <> sEmpty Then
        s = s & "File found in: " & sFullName & sCrLf
    Else
        s = s & "File " & sName & " not found" & sCrLf
    End If
    
    ''@B SearchDirs4
    sName = "EDIT"
    Dim asExts(1 To 4) As String
    asExts(1) = ".EXE": asExts(2) = ".COM"
    asExts(3) = ".BAT": asExts(4) = ".PIF"
    For i = 1 To 4
        sFullName = SearchDirs(sEmpty, sName, asExts(i), _
                               iDir, iBase, iExt)
        If sFullName <> sEmpty Then Exit For
    Next
    ''@E SearchDirs4
    If sFullName <> sEmpty Then
        s = s & "File found in: " & sFullName & sCrLf
    Else
        s = s & "File " & sName & " not found" & sCrLf
    End If

    ' Test GetDiskFreeSpace and GetDriveType
    s = s & sCrLf & "Test GetDiskFreeSpace and GetDriveType" & sCrLf & sCrLf
    Dim iSectors As Long, iBytes As Long
    Dim iFree As Long, iTotal As Long
    Dim rFree As Double, rTotal As Double
    sName = "%:\"
    Dim sTab As String
    For i = 1 To 26
        sVal = Chr$(i + Asc("A") - 1)
        Mid$(sName, 1, 1) = sVal

        ''@B CallGetDriveType
        c = GetDriveType(sName)
        s = s & "Disk " & sVal & " type: "
        s = s & Choose(c + 1, "Unknown", "Invalid", "Floppy ", _
                              "Hard   ", "Network", "CD-ROM ", "RAM    ")
        ''@E CallGetDriveType

        ''@B CallGetDiskFreeSpace
        f = GetDiskFreeSpace(sName, iSectors, iBytes, iFree, iTotal)
        rFree = iSectors * iBytes * CDbl(iFree)
        rTotal = iSectors * iBytes * CDbl(iTotal)
        If f Then
            s = s & " with " & Format$(rFree, "#,###,###,##0")
            s = s & " free from " & Format$(rTotal, "#,###,###,##0") & sCrLf
        ''@E CallGetDiskFreeSpace
        Else
            s = s & sCrLf
        End If
    Next
    ' txtTest.Text = s

    ' Test GetTempPath and GetTempFileName
    s = s & sCrLf & "Test GetTempPath and GetTempFileName" & sCrLf & sCrLf
    c = cMaxPath
    sFullName = String$(c, 0)
    c = GetTempPath(c, sFullName)
    sFullName = Left$(sFullName, c)
    s = s & "Temp Path: " & sFullName & sCrLf
    ''@B GetTempFileName
    sFullName = String$(cMaxPath, 0)
    Call GetTempFileName(".", "HC", 0, sFullName)
    sFullName = Left$(sFullName, InStr(sFullName, sNullChr) - 1)
    ''@E GetTempFileName
    s = s & "Temp File: " & sFullName & sCrLf
    
    s = s & sCrLf & "Test GetTempFile and GetTempDir" & sCrLf & sCrLf
     ''@B GetTempFile1
    ' Get temp file for current directory
    sFullName = GetTempFile(".", "HC")
    ''@E GetTempFile1
    s = s & "Temp file in current directory: " & sFullName & sCrLf
    ''@B GetTempFile2
    ' Get temp file for TEMP directory
    sFullName = GetTempFile(GetTempDir(), "HC")
    ''@E GetTempFile2
    s = s & "Temp file in TEMP directory: " & sFullName & sCrLf

   ' Test GetLogicalDrives
    s = s & sCrLf & "Test GetLogicalDrives" & sCrLf & sCrLf
    sVal = VBGetLogicalDrives()
    s = s & "Drives    ABCDEFGHIJKLMNOPQRSTUVWXYZ" & sCrLf
    s = s & "Drives    " & sVal & sCrLf

    Kill "~HC*.tmp"
    Kill "HC*.tmp"
    
    BugMessage s
    txtTest.Text = s
    
End Sub


Sub ShowStr(s As String)
    Debug.Print s
End Sub

Sub ShowBytes(ab() As Byte)
    Dim i As Integer, iMin As Integer, iMax As Integer, s As String
    iMin = LBound(ab): iMax = UBound(ab)
    For i = iMin To iMax
        s = s & Chr$(ab(i))
    Next
    Debug.Print s
End Sub

#If Win32 = 0 Then
''@B GetMachineName
Private Function GetMachineName(sMachine As String) As Integer
    
    Dim iAx As Long, iCx As Long, f As Integer
    sMachine = String$(16, 0)
    iAx = &H5E00&
    f = Interrupt(&H21, iAx, 0&, iCx, sMachine, 0&, 0&)
    If f Then
        sMachine = sEmpty
        If iCx = 0 Then
            GetMachineName = -1   ' Network not running
        Else
            GetMachineName = -2   ' Network not installed
        End If
    Else
        ' Strip nulls off string
        sMachine = StrZToStr(sMachine)
        GetMachineName = iCx And &HFF&
    End If
        
End Function ''@E GetMachineName

''@B GetVerify
Private Function GetVerify() As Integer
    
    Dim iAx As Long, f As Integer
    iAx = &H5400&
    f = Interrupt(&H21, iAx, 0&, 0&, 0&, 0&, 0&)
    GetVerify = IIf(iAx And &HFF&, True, False)

End Function  ''@E GetVerify

''@B SetVerify
Private Sub SetVerify(f As Integer)
    
    Dim iAx As Long, iZero As Long, fCarry As Integer
    iAx = &H2E00& Or IIf(f, 1, 0)
    fCarry = Interrupt(&H21, iAx, 0&, 0&, 0&, 0&, 0&)

End Sub
''@E SetVerify
#End If

Private Sub mnuCheck_Click()
    mnuCheck.Checked = Not mnuCheck.Checked
End Sub

Private Sub mnuDead_Click()
    MsgBox mnuDead.Caption
End Sub

Private Sub mnuExit_Click()
    Unload Me
End Sub

Private Sub mnuOpen_Click()
    MsgBox mnuOpen.Caption
End Sub

Private Sub mnuGone_Click()
    MsgBox mnuGone.Caption
End Sub

Private Sub mnuCut_Click()
    MsgBox mnuCut.Caption
End Sub

Private Sub mnuPaste_Click()
    MsgBox mnuPaste.Caption
End Sub

Private Sub mnuSome_Click()
    MsgBox mnuSome.Caption
End Sub

Private Sub mnuAll_Click()
    MsgBox mnuAll.Caption
End Sub

Private Sub mnuContents_Click()
    MsgBox mnuContents.Caption
End Sub

Private Sub mnuAbout_Click()
    MsgBox mnuAbout.Caption
End Sub


''@B cmdColor_Click
Private Sub cmdColor_Click()
    Dim getclr As New FGetColor
    Static clrLast As Long
    ' Load last color used
    If clrLast <> 0& Then getclr.Color = clrLast
    getclr.Show vbModal
    ' Save chosen color for next time
    clrLast = getclr.Color
    Me.BackColor = clrLast
End Sub
''@E cmdColor_Click

Private Sub cmdExit_Click()
    Unload Me
End Sub

''@B Form_Activate
Private Sub Form_Activate()
    If fCreated = False Then fCreated = pal.Create(pbColor)
End Sub
''@E Form_Activate

''@B MouseDown
Private Sub pbColor_MouseDown(Button As Integer, Shift As Integer, _
                              x As Single, y As Single)
    If fCreated Then pal.GetColor_MouseDown Button, Shift, x, y
End Sub
''@E MouseDown

Private Sub pbColor_MouseUp(Button As Integer, Shift As Integer, _
                            x As Single, y As Single)
    If fCreated Then pal.GetColor_MouseUp Button, Shift, x, y
End Sub

Private Sub pbColor_Paint()
    If fCreated Then pal.GetColor_Paint
End Sub

''@B Click
Private Sub pbColor_Click()
    BackColor = pal.Color
End Sub
''@E Click

Sub Setting()
    Dim v As Variant
    Dim s As String
    Dim i As Variant

    SaveSetting "George", "Henry", "Bill", "John"
    SaveSetting "George", "Henry", "Joe", "Amy"
    SaveSetting "George", "Henry", "Bob", "Sue"

    v = GetAllSettings("George", "Henry")
    For i = 0 To UBound(v)
        s$ = s$ & v(i, 0) & " = " & v(i, 1) & Chr(13) & Chr(10)
    Next i
    MsgBox s$

End Sub

Private Sub Bytes_Load()
End Sub

''@B WordFromStringB
Function WordFromStringB(sBuf As String, iOffset As Long) As Integer
    BugAssert (iOffset + 2) <= LenB(sBuf) - 1
    Dim dw As Long
    dw = AscB(MidB$(sBuf, iOffset + 2, 1)) * 256&
    dw = dw + AscB(MidB$(sBuf, iOffset + 1, 1))
    If dw And &H8000& Then
        WordFromStringB = &H8000 Or (dw And &H7FFF&)
    Else
        WordFromStringB = dw And &HFFFF&
    End If
End Function
''@E WordFromStringB


