// SRVDATA.H
// 
// Sieve constant definitions and strings. This include files should be
// first in every file. It is the initial file for precompiled headers.
// 

#ifndef _SRVDATA_
#define _SRVDATA_

// One for project
#define szLib 	"SieveServerCpp"
#define szoLib 	OLESTR("SieveServerCpp")

// Server data
#define szLIBID "9040CF50-F060-11ce-8D2E-00AA004A5C59"
#define szTitle "Sieve of Eratosthenes Server As C++ DLL"

// One for each class
#define szIIDSieve 		"9040CF52-F060-11ce-8D2E-00AA004A5C59"
#define szCLSIDSieve 	"9040CF53-F060-11ce-8D2E-00AA004A5C59"
#define szClass			"CCSieve"

const int iMajor = 1;
const int iMinor = 0;

struct CLSDATA {
	char szCls[20];
	char szCLSID[40];
	char szIID[40];
};

extern CLSDATA FAR acls[];
extern HINSTANCE g_hinst;
extern ULONG g_cObj;
extern ULONG g_cLock;

HRESULT LoadResourceTypeLib(REFIID libid, REFIID riid, 
							ITypeInfo FAR* FAR* lplpTInfo);
HKEY RegisterItem(HKEY hKey, const char * szKey, 
				  const char * szVal, int ordSave);
LONG RegDeleteAllKey(HKEY hKey, const char * szKey);

#endif // _SRVDATA_
