Attribute VB_Name = "MSystemImageList"
Option Explicit
#If Win32 Then
DefLng A-Z

'$ Uses FILEINFO.BAS IMGTOOL.BAS

' System image lists

Function GetSysImageList(cCount As Long, Optional vLargeIcon As Variant) As Long
    Dim fi As TFileInfo
    Dim hSysIm As Long, hIcon As Long, af As Long
    If IsMissing(vLargeIcon) Then vLargeIcon = True
    af = SHGFI_SYSICONINDEX Or _
         IIf(vLargeIcon, SHGFI_LARGEICON, SHGFI_SMALLICON)
    hSysIm = SHGetFileInfo("c:\", 0, fi, Len(fi), af)
    cCount = ImageList_GetImageCount(hSysIm)
    GetSysImageList = hSysIm
End Function

Function GetSysIcon(hSysIm As Long, i As Integer, _
    Optional vWidth As Variant, Optional vHeight As Variant) As Picture
    Set GetSysIcon = Nothing
    Dim f As Boolean, cx As Long, cy As Long
    Dim iminf As TImageInfo
    f = ImageList_GetImageInfo(hSysIm, i, iminf)
    If Not f Then Exit Function
    f = ImageList_GetIconSize(hSysIm, cx, cy)
    If Not f Then Exit Function
    ' These just go to temporary variables if missing
    vWidth = cx
    vHeight = cx
    ' Check for bitmap
    If iminf.hbmMask = hNull Then Exit Function
    ' Get icon handle and convert to picture
    Set GetSysIcon = IconToPicture(ImageList_GetIcon(hSysIm, i, ILD_NORMAL))
    
End Function

#End If
