Attribute VB_Name = "MTestSort"
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

Public ordMode As Integer
Public fSortHiToLo As Integer

' Modify to add more sort modes
''@B CallSortCompare
Public Function SortCompare(v1 As Variant, v2 As Variant) As Integer
    ' Use string comparisons only on strings
    If TypeName(v1) <> "String" Then ordMode = ordSortVal
    
    Dim i As Integer
    Select Case ordMode
    ' Sort by value (same as ordSortBin for strings)
    Case ordSortVal
        If v1 < v2 Then
            i = -1
        ElseIf v1 = v2 Then
            i = 0
        Else
            i = 1
        End If
    ' Sort case-insensitive
    Case ordSortText
        i = StrComp(v1, v2, 1)
    ' Sort case-sensitive
    Case ordSortBin
        i = StrComp(v1, v2, 0)
    ' Sort by string length
    Case ordSortLen
        If Len(v1) = Len(v2) Then
            If v1 = v2 Then
                i = 0
            ElseIf v1 < v2 Then
                i = -1
            Else
                i = 1
            End If
        ElseIf Len(v1) < Len(v2) Then
            i = -1
        Else
            i = 1
        End If
    End Select
    If fSortHiToLo Then i = -i
    SortCompare = i
End Function
''@E CallSortCompare
'
