Attribute VB_Name = "MIterateWindows"
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

''@B IterateChildWindows
Public Function IterateChildWindows(ByVal iLevel As Integer, _
                                    ByVal hWnd) ' As SysInt
    Static hRet ' As SysInt
    BugAssert hWnd <> hNull
    ' Assume failure for easy exit
    IterateChildWindows = hNull

    ' Handle current window, allowing user to fail
    hRet = DoWindow(iLevel, hWnd)
    If hRet <> hNull Then Exit Function
    ' Get its child (if any)
    hWnd = GetWindow(hWnd, GW_CHILD)
    ' Iterate through each child window
    Do While hWnd <> hNull
        hRet = IterateChildWindows(iLevel + 1, hWnd)
        If hRet <> hNull Then Exit Function
        ' Get next child
        hWnd = GetWindow(hWnd, GW_HWNDNEXT)
        ' Give other processes some cycles
        DoEvents
    Loop
    IterateChildWindows = hRet

End Function
''@E IterateChildWindows

'
